

MAX17043_ADDR = 0x36
MAX17043_VCELL = 0x02
MAX17043_SOC = 0x04
MAX17043_MODE = 0x06
MAX17043_VERSION = 0x08
MAX17043_CONFIG = 0x0c
MAX17043_COMMAND = 0xfe
MAX17043_Error = 0


class MAX17043():
  
  def __init__(self,bus):
    # pass
    self.bus = bus;
  
  def begin(self):
    # self.write16(MAX17043_COMMAND, 0x5400)
    # time.sleep(0.01)
    
    # self.write16(MAX17043_MODE, 0x4000)
    # time.sleep(0.01)
    #99.398   15:19
    #99.558   15:22
    
    #60S  2
    # 00  
    
    
    #0x80
    #15:31    101.77%
    #15.34    99.87%
    #15.36    97.66%
    #15.41    93.863%  
    #Recharge
    #15:44    94.335%
    #15:46    94.968%
    #15.59    97.816%
    #16:05    99.242%
    
    #0x81
    #16:19    99.242%
    #16:23    96.5507%
    
    
    #0xE0
    #16:24    96.078%
    #16.32    92.121%
    
    #Recharge
    #16.34    91.804%
    #16:56    95.917%
    #17.05    97.660%
    
    
    #13.48    # 100% 
    
    
    self.write16(MAX17043_CONFIG, 0x971C)
    print ("0x%x"%self.read16(MAX17043_CONFIG) )
    return 0
      
  def readVoltage(self):
    return (1.25 * (self.read16(MAX17043_VCELL) >> 4))
  
  def readPercentage(self):
    tmp = self.read16(MAX17043_SOC)
    return ((tmp >> 8) + 0.003906 * (tmp & 0x00ff))
    
    # return 95

  def setInterrupt(self, per):
    if per > 32:
      per = 32
    elif per < 1:
      per = 1
    per = 32 - int(per)
    self.writeRegBits(MAX17043_CONFIG, per, 0x01f, 0)

  def clearInterrupt(self):
    self.writeRegBits(MAX17043_CONFIG, 0, 0x01, 5)
    
  def setSleep(self):
    self.writeRegBits(MAX17043_CONFIG, 1, 0x01, 7)
    
  def setWakeUp(self):
    self.writeRegBits(MAX17043_CONFIG, 0, 0x01, 7)
  
  def write16(self, reg, dat):
    buf = [dat >> 8, dat & 0x00ff]
    self.bus.write_i2c_block_data(MAX17043_ADDR, reg, buf)
    
  def read16(self, reg):
    buf = self.bus.read_i2c_block_data(MAX17043_ADDR, reg, 2)
    return ((buf[0] << 8) | buf[1])
  
  def writeRegBits(self, reg, dat, bits, offset):
    tmp = self.read16(reg)
    tmp = (tmp & (~(bits << offset))) | (dat << offset)
    self.write16(reg, tmp)
